macroScript FBAverageWeights
	category:"Funky Tools"
	toolTip:"FB average skinweights tool"
	buttonText:"Avg Weights"
(
local FBAverageWeightsUI = undefined	
local FBAverageWeightsAbout = undefined
--FBavgWt semi-globals!
FBavgWtCurrObj = undefined
FBavgWtCurrBones =#()
FBavgWtCurrWeights =#()	
	
--defines radial helper objects
SphereOuterHelper1 = undefined
SphereOuterHelper2 = undefined
	
FBavgWtObj1 = undefined
FBavgWtObj2 = undefined
FBavgWtObjSwap = undefined
FBavgWtSwapBones = #()
FBavgWtSwapWeights = #()
FBavgWtUNDO = #()
--FBavgWtREDO = #() haven't messed with this yet
FBavgWtBones1 =#()
FBavgWtBoneWeights1 =#()
FBavgWtBones2 =#()
FBavgWtBoneWeights2 =#()


--just junk for the 'about'/'help' window
randomTip = #( "Blend With [1] or [2] blends the current selection's weights with the respective loaded vert's weights based on Blend Weight", \
						  "[Radial Paste] pastes a linear blend between one of the stored weights and the weight of the selected verts based on distance (Radius)", \
						  "If you have a vert selected on a skin modifier you don't have to go to a subobject mode before running a FBaverage function", \
						  "If you hover over the [Load Vert] buttons it will display the stored values on the tooltip", \
						  "[Paste Gradient] lets you paste a linear blend of the 2 loaded verts' weights upon the selected verts", \
						  "[Use Helper Position] will use the helper's position (and where applicable its radius) for Gradient or Radial functions", \
						  "When [Use Helper Position] is checked on, the script won't update the position of the sphere helpers", \
						  "Loading a vertex will snap the respective helper to its new vertex even if [Use Helper Position] is on", \
						  "[Show/Hide Helpers] will snap helpers back to their source vertices even if [Use Helper Position] is on", \
						  "Moving the window will snap the helpers back to their appropriate positions if the verts have moved (unless Use Helper Positions is enabled)", \
						  "The [Revert Wt] button reverts the skin back past the last blend-paste (this script's dedicated ghetto-undo)", \
						  "The [Store] button will store the current selection of weights into the undo stack so you can reapply them later if you choose", \
						  "When enjoying a night of romance, remember to turn off your cell phone", \
						  "The [flip] button lets you quickly flip the Blend Weight value from one side to the other", \
						  "You can use verts of different objects \nExample:(vert1, vert2, and selected verts could be from 3 different objects!)", \
						  "If you paste a blend with just one vert loaded, the lowest vert (vertID) from the selection will be loaded as the other", \
						  "You can load the 2 verts at once (if pressing the [loadVert1] button, it'll load both if more than one vert is selected)", \
						  "The [Sel] buttons let you select that loaded vertex once again", \
						  "You can change the button images in the ui/macroscripts/FBaverageWeights folder.\nJust save them as .bmps of the same size", \
						  "[Keep bone limits] forces a maintain of the current bone affect limit in the advanced parameters of the selected object's skin modifier", \
						  "[Show/Hide Helpers] will show or delete the helpers (by default they snap to the positions of each loaded vertex)", \
						  "If you don't see the sphere helpers, try changing the radius!", \
						  "Blend will control the weighting for paste blend and blend with: the lower the value the closer to vert2, and vice versa", \
						  "Unnecessary helpers are detected whenever FBaverageWeights is run and may be deleted", \
						  "The helpers can be a useful visual aid to the loaded vertices but remember they don't always refresh when verts move" )
						  
rollout FBAverageWeightsAbout "About FB Average Weights " width:250 height:215
(
	--label Mainshiznit "FB Average Weights 1.2 (for Max'08+)" pos:[8,8]
	groupBox MainSection "FB Average Weights 1.2" pos:[4, 0] width:242 height:125
	hyperlink overlayBlue "FB Average Weights 1.2" pos:[13,0] color: (color 0 0 200) address:"http://www.FunkyBunnies3d.com"
	hyperlink funkySite "Chris 'Funky Bunnies' Whitaker" address:"http://www.FunkyBunnies3d.com" color: (color 0 0 200) pos:[10,14]
	label description "      FB Average Weights is a tool written to help\nblend weights of vertices in a variety of ways\n(rather than Max's LAME individual bone blend)\nQuickStart: \n      Select 2 skin verts and click Load Vert 1 \n      Select other skinverts and click Paste Blend\nDONE! a full average of 2 skin verts!\n" pos:[10,30] width:230 height: 92
	button NextTip "Next Tip" toolTip: "TIPS??? WOW it's just like a REAL annoying About-window!!!" pos:[10,129] width:230 height: 20
	groupBox TipGrp "Random Tip!" pos:[4, 150] width:242 height:60
	
	label Tip "RandomAss tip" pos:[10, 165] width: 230 height:40
	
	on FBAverageWeightsAbout open do
	(
		randomIndex = random 1 randomTip.count	
		TipGrp.caption = ("Random Tip! [#" + randomIndex as string + "]")
		Tip.caption = randomTip[randomIndex]
	)
	on NextTip pressed do
	(	
		randomIndex = 1
		do randomIndex = random 1 randomTip.count		
		while randomTip[randomIndex] == Tip.caption
		
		TipGrp.caption = ("Random Tip! [#" + randomIndex as string + "]")
		Tip.caption = randomTip[randomIndex]
	)
)

	---------------------------------------------------------------------------------------------------------------------------
	-- StoreCurrWeights (index)
	--description: stores a vert's weights and bones as a string into FBavgWtUNDO array
	--input:	index = int vert index on selected object's skin modifier
	--return: (alters FBavgWtUNDO array)
	---------------------------------------------------------------------------------------------------------------------------	
	fn StoreCurrWeights index=	
	(		tempStringBoneID = (index as string + " #(")
			tempStringBoneWeight = ") #("
			tempNumWeights = (skinOps.GetVertexWeightCount $selection[1].modifiers[#Skin] index)
			for j=1 to tempNumWeights do
			(
				tempStringBoneID += (skinOps.GetVertexWeightBoneID $selection[1].modifiers[#Skin] index j) as string
				tempStringBoneWeight += (skinOps.GetVertexWeight $selection[1].modifiers[#Skin] index j) as string
				if (j!=tempNumWeights ) then
				(
					tempStringBoneID += ", "
					tempStringBoneWeight += ", "
				)			
			)
			--insert this brand spankin' new element into array index [2] (index 1 is the object name)
			--note this means it's writing the elements backwards!
			insertItem (tempStringBoneID + tempStringBoneWeight + ")") FBavgWtUNDO 2
	)	
	---------------------------------------------------------------------------------------------------------------------------
	-- SetToolTip (objectNode whichVert vertID)
	--description: sets tooltip for supplied button with object, vertID, and skin weights
	--input:	ObjectNode = Node of object on which VertID was selected
	--			whichVert = int that determines whether it was vert 1 or vert 2
	--			vertID = index of vertex selected within objectNode's skin modifier
	--return: -none-
	---------------------------------------------------------------------------------------------------------------------------
	fn SetToolTip objectNode whichVert vertID=
	(
		tooltipString = ("loaded weights: \n" + objectNode.name)
		tooltipString += (" [" + (vertID as string) + "]")
		
		if whichVert == 1 then
		(
			for i = 1 to FBavgWtBones1.count do
			(
				tooltipString += ( "\n" +FBavgWtBones1[i] as string + ": " + (FBavgWtBoneWeights1[i] as string) )
			)
			FBAverageWeightsUI.loadVert1.tooltip = tooltipString
		)
		else if whichVert == 2 then
		(
			for i = 1 to FBavgWtBones2.count do
			(
				tooltipString += ( "\n" +FBavgWtBones2[i] as string + ": " + (FBavgWtBoneWeights2[i] as string) )
			)
			FBAverageWeightsUI.loadVert2.tooltip = tooltipString
		)
	)
		
	---------------------------------------------------------------------------------------------------------------------------
	-- FindBoneIndex (BoneNode)
	--description: searches for bone index of supplied bone-node within selected object's skin modifier
	--input:	BoneNode = Node for bone to retrieve index
	--return: (int) index of bone within selected object's skin modifier
	---------------------------------------------------------------------------------------------------------------------------
	fn FindBoneIndex BoneNode =
	(
		--should probably also check to see if object has a skin modifier on it
		for i =1 to (skinOps.GetNumberBones $.modifiers[#Skin]) do
		(--sort out so bone indices are applied for selected object, not original objects
				--also look out if bone does not exist
			if (skinOps.GetBoneName $.modifiers[#Skin] i 0) == BoneNode do
			(	print ("Found: " + BoneNode as string + " = " + (skinOps.GetBoneName $selection[1].modifiers[#Skin] i 0) as string + " at " + i as string)
				
				return (int(i)) 
			)
		)	
		return 0 --otherwise return false
	)
	
	---------------------------------------------------------------------------------------------------------------------------
	-- LoadCurrVert (SentIndex)
	--description: Loads sent Index on current object to temporary vars for blending (blendWith/radial paste, etc)
	--input:	SentIndex = index of vertex on selected object as sent by another function
	--return: 1 if successful, 0 if not
	---------------------------------------------------------------------------------------------------------------------------
	fn LoadCurrVert SentIndex = 
	(
			FBavgWtCurrObj = $selection[1]
			FBavgWtCurrBones =#()
			FBavgWtCurrWeights =#()
				
			try
			(
				for h=1 to (skinOps.GetVertexWeightCount FBavgWtCurrObj.modifiers[#Skin] SentIndex) do
				(
					append FBavgWtCurrBones (skinOps.GetVertexWeightBoneID FBavgWtCurrObj.modifiers[#Skin] SentIndex h)
					append FBavgWtCurrWeights (skinOps.GetVertexWeight FBavgWtCurrObj.modifiers[#Skin] SentIndex h)
				)
				--print "Temp Vert weights: "
				--	print FBavgWtCurrBones
				--	print FBavgWtCurrWeights
				return 1
			)
			catch( return 0 )
	)
	
	---------------------------------------------------------------------------------------------------------------------------
	-- LoadFirstVert (JustOne)
	--description: loads first vert, if true, loads to memory to discard later, if false to ui and save
	--input:	JustOne = boolean to determine if it should store 1 or 2 verts from selection
	--return: (int) 1 if successful, 0 if not... I think
	---------------------------------------------------------------------------------------------------------------------------
	fn LoadFirstVert JustOne =
		(
			--abort if no objects selected
			if ($selection.count < 1) then
				return 0
			max modify mode
			if (classOf (modPanel.getCurrentObject()) != Skin) then
			(
				skinMod = $selection[1].modifiers[#Skin]
				--as long as skin modifier exists, set it to current object
				if skinMod != undefined then	modPanel.setCurrentObject skinMod 
				else return 0 --otherwise abort
			)
			subobjectLevel = 1
				
			numSelected = 0
			for i = 1 to(skinOps.GetNumberVertices $selection[1].modifiers[#Skin]) do
				if (skinOps.IsVertexSelected $selection[1].modifiers[#Skin] i)==1 then
				(	
					if numSelected == 0 then
					(	--increment # selected and write number to button
						numSelected += 1
						FBavgWtObj1 = $selection[1]
						FBavgWtBones1 =#()
						FBavgWtBoneWeights1 =#()
						

							for h=1 to (skinOps.GetVertexWeightCount FBavgWtObj1.modifiers[#Skin] i) do
						(
							initBoneID = (skinOps.GetVertexWeightBoneID FBavgWtObj1.modifiers[#Skin] i h)
							initBoneNode = (skinOps.GetBoneName FBavgWtObj1.modifiers[#Skin] initBoneID 0)
							append FBavgWtBones1 (initBoneNode)
							append FBavgWtBoneWeights1 (skinOps.GetVertexWeight FBavgWtObj1.modifiers[#Skin] i h)
						)
						print "Vert 1 weights: "
							print FBavgWtBoneWeights1
						
							FBAverageWeightsUI.selectVert1.enabled = true
							FBAverageWeightsUI.loadVert1.caption = ("Vertex " + i as string)
							SetToolTip (FBavgWtObj1) (1) (i)
					)
					else if numSelected == 1 And Not JustOne then
					(	--increment # selected and write to 2nd button if there are more than 1 verts selected - maybe this would be useful? i dunno
						numSelected += 1
						FBavgWtObj2 = $selection[1]
						FBavgWtBones2 =#()
						FBavgWtBoneWeights2 =#()
						FBAverageWeightsUI.selectVert2.enabled = true
						
						for h=1 to (skinOps.GetVertexWeightCount FBavgWtObj2.modifiers[#Skin] i)  do
						(
							initBoneID = (skinOps.GetVertexWeightBoneID FBavgWtObj2.modifiers[#Skin] i h)
							initBoneNode = (skinOps.GetBoneName FBavgWtObj2.modifiers[#Skin] initBoneID 0)
							append FBavgWtBones2 (initBoneNode)
							append FBavgWtBoneWeights2 (skinOps.GetVertexWeight FBavgWtObj2.modifiers[#Skin] i h)
						)
						print "Vert 2 weights: "
							print FBavgWtBoneWeights2
						FBAverageWeightsUI.loadVert2.caption = ("Vertex " + i as string)
						SetToolTip (FBavgWtObj2) (2) (i)
						
					)
					else return 1 --otherwise it's time to exit!
				)
		)
		
	---------------------------------------------------------------------------------------------------------------------------
	-- LoadSecVert 
	--description: loads second vert, if true, loads to memory to discard later, if false to ui and save
	--input:	none
	--return: 1 if successful, 0 if not... I think
	---------------------------------------------------------------------------------------------------------------------------
	fn LoadSecVert = 
	(
		--abort if no objects selected
		if ($selection.count < 1) then
			return 0
		
		max modify mode --switch to modify panel
		--if skin modifier isn't selected, select it as long as it exists
		if (classOf (modPanel.getCurrentObject()) != Skin) then
			(
				skinMod = $selection[1].modifiers[#Skin]
				if skinMod != undefined then	modPanel.setCurrentObject skinMod 
				else return 0 --otherwise abort
			)
			subobjectLevel = 1
				
		numSelected = 0
			for i = 1 to(skinOps.GetNumberVertices $selection[1].modifiers[#Skin]) do
				if (skinOps.IsVertexSelected $selection[1].modifiers[#Skin] i)==1 then
				(	
					if numSelected == 0 then
					(	--if none have been found yet, store to button
						numSelected += 1
						FBavgWtObj2 = $selection[1]
						FBavgWtBones2 =#()
						FBavgWtBoneWeights2 =#()
						
						
						for h=1 to (skinOps.GetVertexWeightCount FBavgWtObj2.modifiers[#Skin] i)  do
						(
							initBoneID = (skinOps.GetVertexWeightBoneID FBavgWtObj2.modifiers[#Skin] i h)
							initBoneNode = (skinOps.GetBoneName FBavgWtObj2.modifiers[#Skin] initBoneID 0)
							append FBavgWtBones2 (initBoneNode)
							append FBavgWtBoneWeights2 (skinOps.GetVertexWeight FBavgWtObj2.modifiers[#Skin] i h)
						)
						print "Vert 2 weights: "
							print FBavgWtBoneWeights2
						
							FBAverageWeightsUI.selectVert2.enabled = true
							FBAverageWeightsUI.loadVert2.caption = ("Vertex " + i as string)
							SetToolTip (FBavgWtObj2) (2) (i)
						
						return 1 --now it's time for exitin'!
					)
				)
	)	
		

	-------------------------------------------------------------------------------------------------------------------------
	--FBAverageWeightsOne (index Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight maintainBoneLimit BlendCurr)
	--description: actually does the shiznit on one vertex as sent via 'index'
	--input:	
	--			index = index of vertex to manipulate
	--			Vert1 = index of vertex 1 from FBavgWtObj1
	--			Vert2 = index of vertex 2 from FBavgWtObj2
	--			FBavgWtObj1 = object on which Vert1 was selected
	--			FBavgWtObj2 = object on which Vert2 was selected
	--			blendWeight  = float value for interpolation (.5 is half)
	--			maintainBoneLimit = boolean to tell whether or not to keep bone influence limits
	--			BlendCurr = blend option - sets whether to blend current weights with vert 1, 2 or just blend between vet 1 and 2 instead
	--return: -none-
	---------------------------------------------------------------------------------------------------------------------------
	fn FBAverageWeightOne index Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight maintainBoneLimit BlendCurr=
	(
		boneID =#()
		boneWeights =#()
		
		tempBoneID1 = #()
		tempBoneID2 = #()
		--check for BoneID1
		
	--store bone ID's associated with names to temporary arrays
		for i=1 to FBavgWtBones1.count do
		(
			append tempBoneID1 (FindBoneIndex (FBavgWtBones1[i]))
		)
		for i=1 to FBavgWtBones2.count do
			append tempBoneID2 (FindBoneIndex (FBavgWtBones2[i]))
						
		--if BlendCurr set to 1, blend current vertex's weight with vertex1 and vert2 is actually the blend vertex
		if BlendCurr == 1 then
		(			
		--check in BoneID1 and save to arrays
			for i=1 to tempBoneID1.count do
			(
				--as long as id[i] doesn't equal 0, continue (0 index doesnt exist, was passed earlier for an error)
				if tempBoneID1[i] != 0 do
				(
					--check to see if bone also exists in BoneCurrID2[]
					index2 = findItem FBavgWtCurrBones tempBoneID1[i]
					--store to master BoneID[]
					append boneID tempBoneID1[i]
					
					if (index2 > 0) then --if found in boneID2 as well... blend with vert2's weight
						append boneWeights  (((1-blendWeight)*FBavgWtCurrWeights[index2]) + (blendWeight*FBavgWtBoneWeights1[i]) )
					else --otherwise blend with 0
						append boneWeights ( blendWeight*FBavgWtBoneWeights1[i] ) 
				)
			)
		--check for BoneCurrID
			for i=1 to FBavgWtCurrBones.count do
			(
				if FBavgWtCurrBones[i] != 0 do
				(--check to see if FBavgWtCurrBones[i] doesn't exist within master boneID[]
					UniqueOrNot = appendIfUnique boneID FBavgWtCurrBones[i]
			
					if(UniqueOrNot) then --if doesn't exist in master BoneID[] yet, add it in! it's a party!
						append boneWeights ((1-blendWeight)*FBavgWtCurrWeights[i] )
				)
			)
		)
		else if BlendCurr == 2 then
		(
			--check in BoneID1 and save to arrays
			for i=1 to FBavgWtCurrBones.count do
			(
				--as long as id[i] doesn't equal 0, continue (0 index doesnt exist, was passed earlier for an error)
				if FBavgWtCurrBones[i] != 0 do
				(
					--store to master BoneID[]
					append boneID FBavgWtCurrBones[i]
					
					--check to see if bone also exists in BoneCurrID2[]
					index2 = findItem tempBoneID2 FBavgWtCurrBones[i]
										
					if (index2 > 0) then --if found in boneID2 as well... blend with vert2's weight
						append boneWeights  (((1-blendWeight)*FBavgWtBoneWeights2[index2]) + (blendWeight*FBavgWtCurrWeights[i]) )
					else --otherwise blend with 0
						append boneWeights ( blendWeight*FBavgWtCurrWeights[i] ) 
				)
			)
		--check for BoneCurrID
			for i=1 to tempBoneID2.count do
			(
				
				if tempBoneID2[i] != 0 do
				(--check to see if FBavgWtCurrBones[i] doesn't exist within master boneID[]
					UniqueOrNot = appendIfUnique boneID tempBoneID2[i]
			
					if(UniqueOrNot) then --if doesn't exist in master BoneID[] yet, add it in! it's a party!
						append boneWeights ((1-blendWeight)*FBavgWtBoneWeights2[i] )
				)
			)
		)
		else --otherwise don't worry about blendCurr and just blend between two stored weights
		(
			for i=1 to FBavgWtBones1.count do
			(
				--as long as id[i] doesn't equal 0, continue (0 index doesnt exist, was passed earlier for an error)
				if tempBoneID1[i] != 0 do
				(
					--check to see if bone also exists in BoneID2[]
					index2 = findItem tempBoneID2 tempBoneID1[i]
					--store to master BoneID[]
					append boneID tempBoneID1[i]
					
					if (index2 > 0) then --if found in boneID2 as well... blend with vert2's weight
						append boneWeights  (((1- blendWeight)*FBavgWtBoneWeights2[index2]) + (blendWeight*FBavgWtBoneWeights1[i]) )
					else --otherwise blend with 0
						append boneWeights ( (blendWeight)*FBavgWtBoneWeights1[i] ) 
				)
			)
			--check for BoneID2
			for i=1 to FBavgWtBones2.count do
			(
				
				if tempBoneID2[i] != 0 do
				(--check to see if BoneID2[i] doesn't exist within master boneID[]
					UniqueOrNot = appendIfUnique boneID tempBoneID2[i]
			
					if(UniqueOrNot) then --if doesn't exist in master BoneID[] yet, add it in! it's a party!
						append boneWeights ((1- blendWeight)*FBavgWtBoneWeights2[i] )
				)
			)
		)
		
			--edit captions to say that data is cached if any selected vert is one of the loaded verts
				if $selection[1] == FBavgWtObj1 then
					if index == Vert1 And Not (FBAverageWeightsUI.loadVert1.caption == "Load Vert 1") do
						FBAverageWeightsUI.loadVert1.caption = ("Cached " + Vert1 as string)
				if $selection[1] == FBavgWtObj2 then
					if index == Vert2 And Not (FBAverageWeightsUI.loadVert2.caption == "Load Vert 2") do
						FBAverageWeightsUI.loadVert2.caption = ("Cached " + Vert2 as string)		
				
				initLimit = $selection[1].modifiers[#Skin].bone_Limit
				
				--if # influences is higher than bone limit raise it
				if $selection[1].modifiers[#Skin].bone_Limit < boneID.count do 
					$selection[1].modifiers[#Skin].bone_Limit = boneID.count
				skinOps.ReplaceVertexWeights $selection[1].modifiers[#Skin] index boneID BoneWeights
				
				--if init bone limit was changed and option was set to preserve bone limit, reapply it (this should cull smallest weighted bones)
				if maintainBoneLimit do
					$selection[1].modifiers[#Skin].bone_Limit = initLimit
		
	)
	
	-------------------------------------------------------------------------------------------------------------------------
	--FBAverageWeights (Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight maintainBoneLimit BlendCurr)
	--description: Blends weights between 2 vertices in a variety of ways, calls FBAverageWeightsOne
	--input:	Vert1 = index of vertex 1 from FBavgWtObj1
	--			Vert2 = index of vertex 2 from FBavgWtObj2
	--			FBavgWtObj1 = object on which Vert1 was selected
	--			FBavgWtObj2 = object on which Vert2 was selected
	--			blendWeight  = float value for interpolation (.5 is half)
	--			maintainBoneLimit = boolean to tell whether or not to keep bone influence limits
	--			BlendCurr = blend option - blend current weights with vert 1, 2 or just blend between vet 1 and 2
	--return: -none-
	---------------------------------------------------------------------------------------------------------------------------
	fn FBAverageWeights Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight maintainBoneLimit BlendCurr=
	(
		try
		(
			FBAverageWeightsUI.UndoLast.enabled = true
			insertItem $selection[1] FBavgWtUNDO 1
			
			--apply new weights
			numSkinVerts = skinOps.GetNumberVertices $selection[1].modifiers[#Skin]
			
			for i = 1 to numSkinVerts  do
				if (skinOps.IsVertexSelected $selection[1].modifiers[#Skin] i)==1 then
				(	
					--edit captions to say that data is cached if any selected vert is one of the loaded verts
					if $selection[1] == FBavgWtObj1 then
						if i == Vert1 And Not (FBAverageWeightsUI.loadVert1.caption == "Load Vert 1") do
							FBAverageWeightsUI.loadVert1.caption = ("Cached " + Vert1 as string)
					if $selection[1] == FBavgWtObj2 then
						if i == Vert2 And Not (FBAverageWeightsUI.loadVert2.caption == "Load Vert 2") do
							FBAverageWeightsUI.loadVert2.caption = ("Cached " + Vert2 as string)		
					
					StoreCurrWeights (i)
					if BlendCurr > 0 then LoadCurrVert (i)
					FBAverageWeightOne i Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight maintainBoneLimit BlendCurr
					FBavgWtCurrBones = #()
					FBavgWtCurrWeights = #()
				)
		)
		catch (print "an error occurred and FB average Weights aborted this function")
			
	)
	-------------------------------------------------------------------------------------------------------------------------
	--GradientAverageWeights (Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight useHelpers maintainBoneLimit)
	--description: automatic gradient between Vert1 and Vert2 world positions, calls FBAverageWeightsOne
	--input:	Vert1 = index of vertex 1 from FBavgWtObj1
	--			Vert2 = index of vertex 2 from FBavgWtObj2
	--			FBavgWtObj1 = object on which Vert1 was selected
	--			FBavgWtObj2 = object on which Vert2 was selected
	--			blendWeight  = float value for interpolation (.5 is half)
	--			useHelpers = bool whether or not to store helper positions as start/end vs. using the actual vert positions
	--			maintainBoneLimit = boolean to tell whether or not to keep bone influence limits
	--			BlendCurr = blend option - blend current weights with vert 1, 2 or just blend between vet 1 and 2
	--return: -none-
	---------------------------------------------------------------------------------------------------------------------------
	fn GradientAverageWeights Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight useHelpers maintainBoneLimit=
	(
		
		try
		(
		-- grab start and endpoint to set up distance shiznit
			startpoint = FBavgWtObj1.verts[Vert1].pos
			endpoint = FBavgWtObj2.verts[Vert2].pos
		--if set to use helper positions, use those instead of the vert positions
			if useHelpers do
			(	
				try
				(
					startpoint = SphereOuterHelper1.pos
					endpoint = SphereOuterHelper2.pos
				)
				catch(messageBox "No valid Radial Helpers found! \nYou must toggle them on before using this function")
			)
			range = distance startpoint endpoint
			
		--vector time!
			--create unit vector of start point to end point so we can easily get point's distance along vector
			UnitVectorBase = normalize(endpoint - startpoint)	
			--initialize point3 variable for vector [startVert-selectedVert]
			VectorPoint = [0, 0, 0] 
			--do the rest in the loops per-vertex
			
			initLimit = $selection[1].modifiers[#Skin].bone_Limit
			FBAverageWeightsUI.UndoLast.enabled = true
			insertItem $selection[1] FBavgWtUNDO 1
			
			for h = 1 to (skinOps.GetNumberVertices $selection[1].modifiers[#Skin]) do
			(
				if (skinOps.IsVertexSelected $selection[1].modifiers[#Skin] h)==1 then
				(
					VectorPoint = (($.verts[h].pos) - startpoint)
				
				--take dot product of Vec(Start-Point) and Vec(Start-End) and divide by range to point's position across length
					gradientWeight = ((dot VectorPoint UnitVectorBase)/(range) )
			
				--if above or below, set to max or min weight
					if gradientWeight > 1 then
						gradientWeight = 0
					else if gradientWeight < 0 then
						gradientWeight = 1
					else
						gradientWeight = 1-gradientWeight
					--invert gradientWeight before passing to function - for linear gradient, the points are reversed!
					--store current weights for undo
					StoreCurrWeights h
					--change weights
					FBAverageWeightOne h Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 gradientWeight maintainBoneLimit 0
				)
			)			
		)
		catch (print "aborted Paste Gradient, a loaded vertex may no longer exist?")
	)
	

	-------------------------------------------------------------------------------------------------------------------------
	--RadialAverageWeights (WhichVert LoadedVert LoadedObj falloffRadius centerPoint maintainBoneLimit)
	--description: Paste weights based on distance (falloffRadius)
	--input:	WhichVert = int of which vert was sent (1 or 2)
	--			LoadedVert = index of either Vert1 or Vert2
	--			LoadedObj = object node, either FBavgWtObj1 or FBavgWtObj2
	--			falloffRadius = float of distance from loaded vert to have influence
	--			centerPoint = int to determine what to use as startpoint where 0 is default (loaded vert position), 1 is helper1, and 2 is helper2
	--			maintainBoneLimit = boolean to tell whether or not to keep bone influence limits
	--return: -none-
	---------------------------------------------------------------------------------------------------------------------------	
	fn RadialAverageWeights WhichVert LoadedVert LoadedObj falloffRadius centerPoint maintainBoneLimit=
	(
		try
		(
			-- grab endpoint and setup inverse map matrix
			startpoint = LoadedObj.verts[LoadedVert].pos
			try 
			(
				if centerPoint == 1 then
					startpoint = SphereOuterHelper1.pos
				else if centerPoint == 2 then
					startpoint = SphereOuterHelper2.pos
			)
			catch
			(
				messageBox "No valid Radial Helper found! \nYou must toggle it on before using this function"
				return 0
			)
			
			initLimit = $selection[1].modifiers[#Skin].bone_Limit
			FBAverageWeightsUI.UndoLast.enabled = true
			insertItem $selection[1] FBavgWtUNDO 1
			
			for h = 1 to (skinOps.GetNumberVertices $selection[1].modifiers[#Skin]) do
			(
				if (skinOps.IsVertexSelected $selection[1].modifiers[#Skin] h)==1 then
				(
					currpoint = $selection[1].verts[h].pos
				--find distance between loaded Vertex and selected vertex, then divide by falloff to determine weight
					radialWeight = ((distance startpoint currpoint)/falloffRadius)
				--print falloffRadius
					
					
					--set to correct weight if above/below certain point
					if radialWeight > .99999 then radialWeight = 0
					else radialWeight = 1-radialWeight
					--print radialWeight	
			--print (h as string + "= " + radialWeight as string)
					--store current weights for undo
					StoreCurrWeights h
					--load current loop vert (h) into FBavgWtCurr* arrays etc
					LoadCurrVert h
					
					--change weights
					if WhichVert ==1 then
						FBAverageWeightOne h LoadedVert h LoadedObj FBavgWtObj2 radialWeight maintainBoneLimit WhichVert
					else
						FBAverageWeightOne h h LoadedVert FBavgWtObj1 LoadedObj  (1-radialWeight) maintainBoneLimit WhichVert
				)
			)
		)
		catch (print "aborted Radial Paste, last loaded vert may not longer exist")
	)
	
	--create rollout and gui items for FBaverageWeights
	--also create onpress functions etc
	rollout FBAverageWeightsUI "FB Average Weights 1.2"
	(	
	groupBox TopGrp "" pos:[2, -3] width:216 height:32
	checkButton maintainBoneLimit "Keep bone limit" pos:[114,8] width: 80 height: 16 checked:true tooltip:"Force maintain # of bones on selected vertices"
		button AboutThis "?" pos:[198,8] width:16 height:16 toolTip:"Huh? What? Help?"
	button UndoLast "Revert Wt" enabled: false pos:[8,8] width: 60 height: 16 toolTip:"Revert to stored weights (stores weights before any averageWeights automatically)"
			button StoreCurr "Store" pos:[68,8] width: 40 height: 16 toolTip:"Stores selected weights in case you want to revert (any averageWeights will save automatically)"
		
	groupBox HelperGrp "" pos:[2, 22] width:109 height:140
	groupBox BlendWtGrp "" pos:[5, 38] width:81 height:56
		button loadVert1 "Load Vert 1" pos:[8,32] width:78 height:24 toolTip:"Load selected vertex as 1"
			button selectVert1 "Sel" enabled: false pos:[86, 32] width:21 height:24 toolTip:"re-select Vertex 1"
		spinner blendWeight "Blend:" pos:[26,61] width:60 height:16 range:[0,1,.5] scale:.05
		label blendWeightPtr ">" pos:[2,60]
			button blendInv "flip" pos:[86,61] width:20 height:16 toolTip:"Invert Blend Weight"
		button loadVert2 "Load Vert 2" pos:[8,82] width:78 height:24 toolTip:"Load selected vertex as 2"
			button selectVert2 "Sel" enabled: false pos:[86,82] width:21 height:24 toolTip:"re-select Vertex 2"
	groupBox LoadGrp "" pos:[2, 22] width:109 height:89
	
	groupBox RadialGrp "" pos:[110, 22] width:108 height:140
	groupBox GradientGrp "" pos:[110, 22] width:108 height:89
	groupBox BlendGrp "" pos:[110, 22] width:108 height:56
		
		button DoIt "Paste Blend" pos:[114,32] width:100 height:24 toolTip:"Apply blended weight to selection of skin verts based on Blend Weight"
		
		button Blend1 "Blend with: 1" pos:[114,56] width:83 height:18 toolTip:"Blend vert1 with selection based on Blend Weight"
		button Blend2 "2" pos:[197,56] width:17 height:18 toolTip:"Blend vert2 with selection based on Blend Weight"
		
		button BlendGradient "Paste Gradient" pos:[114,82] width:100 height: 24 toolTip:"Paste blended weight on selection gradually between loaded verts \n(Blend Weight currently has no effect)"
		
		button BlendRadial1 "Radial Paste 1" pos:[114,114] width:82 height: 24 toolTip:"Paste loaded Vert1 with a radial falloff over selection\n(Blend Weight currently has no effect)"
		button BlendRadial2 "2" pos:[194,114] width:20 height: 24 toolTip:"Paste loaded Vert2 with a radial falloff (Radius) over selection \n(Blend Weight currently has no effect)"
		spinner RadialFalloff "Radius:" pos:[130,142] width:84 height:16 range:[0,10000,.1] scale:0.01
		
		button ShowHideHelpers "Show/Hide Helpers" pos:[8,114] width:99 height: 24 toolTip:"Show/Hide Sphere helpers on loaded verts (if you can't see them check your layer visibility!)"
		checkButton useHelpersBut "Use Helper Position" pos:[8,142] width: 99 height: 16 checked:false tooltip:"Use helper positions for radial and gradient functions"
		
	--when rollout dialog is closed, delete any helpers
		on FBAverageWeightsUI close do
		(
			if isValidNode SphereOuterHelper1 then delete SphereOuterHelper1
			if isValidNode SphereOuterHelper2 then delete SphereOuterHelper2
		)
	
		on FBAverageWeightsUI open do
		(
			try 
			(
				FBAverageWeightsUI.DoIt.images = #("FBavgWt_PasteBlend.bmp", undefined, 1,1,1,1,1 )
			
				FBAverageWeightsUI.Blend1.images = #("FBavgWt_BlendWith1.bmp", undefined, 1,1,1,1,1 )
				FBAverageWeightsUI.Blend2.images = #("FBavgWt_BlendWith2.bmp", undefined, 1,1,1,1,1 )
				
				FBAverageWeightsUI.BlendGradient.images = #("FBavgWt_PasteGradient.bmp", undefined, 1,1,1,1,1 )
				
				FBAverageWeightsUI.BlendRadial1.images = #("FBavgWt_PasteRadial1.bmp", undefined, 1,1,1,1,1 )
				FBAverageWeightsUI.BlendRadial2.images = #("FBavgWt_PasteRadial2.bmp", undefined, 1,1,1,1,1 )
			)
			catch (messageBox "Couldn't find button images in ProgramFiles/Autodesk/3dsMaxXXXX/ui/macroscripts/FBaverageWeights!\nUsing text buttons instead")
		)
		
	--when rollout dialog is moved, refresh the helpers' position to snap to verts unless use helpers is on
		on FBAverageWeightsUI  moved pos do
		(
			useHelpers = useHelpersBut.checked
			
			if Not useHelpers do
			(
				if isValidNode FBavgWtObj1 then
				(
					if isValidNode SphereOuterHelper1 then 
					(
						SphereOuterHelper1.pos = FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos
					)
				)
				
				if isValidNode FBavgWtObj2 then
				(
					if isValidNode SphereOuterHelper2 then 
					(
						SphereOuterHelper2.pos = FBavgWtObj2.verts[(substring loadVert2.caption 8 -1) as integer].pos
					)
				)
			)
		)
	--when '?' (about) button is pressed, pop up about window (rollout at top of script)
		on AboutThis pressed do
		(
			CreateDialog FBAverageWeightsAbout
		)
		
	--when Radius spinner changed
		on RadialFalloff changed val do
		(
			if isValidNode FBavgWtObj1 then
			(
				if isValidNode SphereOuterHelper1 then 
				(
					SphereOuterHelper1.radius = val
					if Not useHelpersBut.checked do
						SphereOuterHelper1.pos = FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos
				)
				else
				(
					VertPos = FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos
					SphereOuterHelper1 = SphereGizmo name:"FBAvgWt_RadialHelper1" radius:val pos:VertPos
					SphereOuterHelper1.scale.controller = Scale_Expression ()
				)
			)
			if isValidNode FBavgWtObj2 then
			(
				if isValidNode SphereOuterHelper2 then 
				(
					--SphereOuterHelper2.radius = val
					SphereOuterHelper2.iconSize = val
					if Not useHelpersBut.checked do
						SphereOuterHelper2.pos = FBavgWtObj2.verts[(substring loadVert2.caption 8 -1) as integer].pos
				)
				else
				(
					VertPos = FBavgWtObj2.verts[(substring loadVert2.caption 8 -1) as integer].pos
					--SphereOuterHelper2 = SphereGizmo name:"FBAvgWt_RadialHelper2" radius:val pos:VertPos
					SphereOuterHelper2 = gravity name:"FBAvgWt_RadialHelper2" iconSize:val pos:VertPos gravitytype:1
					SphereOuterHelper2.scale.controller = Scale_Expression ()
				)
			)
		)
		--wait what if currently active layer is hidden? shiit.
	
	--Paste Gradient
		on BlendGradient pressed do
		(
			if (loadVert1.caption == "Load Vert 1" Or loadVert2.caption == "Load Vert 2" Or $selection.count < 1) then return 0
					
			GradientAverageWeights ((substring loadVert1.caption 8 -1) as integer)  ((substring loadVert2.caption 8 -1) as integer) FBavgWtObj1 FBavgWtObj2 (blendWeight.value as float) (useHelpersBut.checked) maintainBoneLimit.checked
		)
		
	--Radial Paste 1
		on BlendRadial1 pressed do
		(
			radialDist = (RadialFalloff.value as float)
			radialPoint = 0
			if isValidNode SphereOuterHelper1 then 
				if useHelpersBut.checked then
				(
					radialDist = SphereOuterHelper1.radius
					radialPoint = 1
				)
				
			if $selection.count < 1 then return 0
			else if (loadVert1.caption != "Load Vert 1") then
				RadialAverageWeights 1 ((substring loadVert1.caption 8 -1) as integer)  FBavgWtObj1 radialDist radialPoint maintainBoneLimit.checked
		)
		
	--Radial Paste 2
		on BlendRadial2 pressed do
		(
			radialDist = (RadialFalloff.value as float)
			radialPoint = 0
			if isValidNode SphereOuterHelper2 then 
				if useHelpersBut.checked then
				(
					--radialDist = SphereOuterHelper2.radius
					radialDist = SphereOuterHelper2.iconSize
					radialPoint = 2
				)
				
			if $selection.count < 1 then return 0
			else if (loadVert2.caption != "Load Vert 2") then
				RadialAverageWeights 2 ((substring loadVert2.caption 8 -1) as integer)  FBavgWtObj2 radialDist radialPoint maintainBoneLimit.checked
		)
		
	--when Store button is pressed, store the weights to the undo queue
		on StoreCurr pressed do
		(
			if $selection.count<1 then return 0
			else
			(
				max modify mode
				
				try
				(				
					insertItem $selection[1] FBavgWtUNDO 1
					numSkinVerts = skinOps.getNumberVertices $selection[1].modifiers[#Skin]
					for i = 1 to numSkinVerts do
						if (skinOps.IsVertexSelected $selection[1].modifiers[#Skin] i)==1 then
							StoreCurrWeights (i)
					
					UndoLast.enabled = true
				)
				catch(return 0)
			)
		)
	
	--when Revert Wt button is pressed, undo this shiznit
		on UndoLast pressed do
		(--as long as the weight-undo array's count is more than 1 then restore weights (index [1] stores object node)
			Vert1 = ((substring loadVert1.caption 8 -1) as integer)
			Vert2 = ((substring loadVert2.caption 8 -1) as integer)
			
			try
			(
				if (FBavgWtUNDO.count >1) then
				(
					max modify mode
					if (classOf (modPanel.getCurrentObject()) != Skin) then
					(
						skinMod = FBavgWtUNDO[1].modifiers[#Skin]
						if skinMod != undefined then	modPanel.setCurrentObject skinMod 
						else return 0 --otherwise abort
					)
					subobjectLevel = 1
					
					
					FBavgWtUNDO[1].modifiers[#Skin].filter_vertices = on
					--for i=2 to FBavgWtUNDO.count do
					--get rid of stored object name since we already selected it and all that shiznit
					FBavgWtUNDO = deleteItem FBavgWtUNDO 1
					
					while true do
					(
						--keep index at 1 because we're deleting the FUCK outta array elements
						i = 1
						
					--if current index is a string value, it's a vertex string, so replace the weights for it
					--if it's not a string, then I don't even care about it anymore, so exit the loop
						if (classOf (FBavgWtUNDO[i]) == String ) then
						(
							execute ("skinOps.ReplaceVertexWeights $selection[1].modifiers[#Skin] " + FBavgWtUNDO[i] )
							FBavgWtUNDO = deleteItem FBavgWtUNDO 1
						)
						else exit
					)
				)
			)
			catch(messagebox "OHSHI- looks like you may have deleted the object that the undo was on or it's not from this scene!  \nThe easiest way to flush it is to just close and restart FBaverageWeights.")
			
			if (FBavgWtUNDO.count <1) then
				UndoLast.enabled = false
		)

		
	--when loading first vert...	
		on loadVert1 pressed do
		(
			LoadFirstVert (false) --LoadFirstVert function, NOT temporary
			
			if Not useHelpersBut.checked then
			(
				if isValidNode SphereOuterHelper1 then 
				(
					delete SphereOuterHelper1
					try
					(
						--set val = radius, set position to vertPosition, make sphere helper, and lock scale by setting a blank expression controller
						val = RadialFalloff.value
						VertPos = FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos
						SphereOuterHelper1 = SphereGizmo name:"FBAvgWt_RadialHelper1" radius:val pos:VertPos
						SphereOuterHelper1.scale.controller = Scale_Expression ()
					)catch()
				)
				if isValidNode SphereOuterHelper2 then 
				(
					delete SphereOuterHelper2
					try
					(
						val = RadialFalloff.value
						VertPos = FBavgWtObj2.verts[(substring loadVert2.caption 8 -1) as integer].pos
						--SphereOuterHelper2 = SphereGizmo name:"FBAvgWt_RadialHelper2" radius:val pos:VertPos
						SphereOuterHelper2 = gravity name:"FBAvgWt_RadialHelper2" iconSize:val pos:VertPos gravitytype:1
						SphereOuterHelper2.scale.controller = Scale_Expression ()
					)catch()
				)
			)
			else
			(
				try
				(
					SphereOuterHelper1.pos = (FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos)
				)catch()
			)
		)

	--when selecting stored vertex1
		on selectVert1 pressed do
		(
			if Not (isValidNode FBavgWtObj1) do return 0
			try
			(
				max modify mode
				if (classOf (modPanel.getCurrentObject()) != Skin) then
					modPanel.setCurrentObject FBavgWtObj1.modifiers[#Skin]
				subobjectLevel = 1
				FBavgWtObj1.modifiers[#Skin].filter_vertices = on
				skinOps.SelectVertices FBavgWtObj1.modifiers[#Skin] ((substring loadVert1.caption 8 -1) as integer)
			)
			catch ()
		)
		
	--when blendWeight value changes
		on blendWeight changed val do
			blendWeightPtr.pos.y = (36+(1-val)*50 ) --magic numbers for the ui pointer between the blendweight verts
		
	--invert blendweight
		on blendInv pressed do
		(	
			blendWeight.value = (1-blendWeight.value)
			val = blendWeight.value
			blendWeightPtr.pos.y = (36+(1-val)*50 ) --magic numbers for the ui pointer between the blendweight verts
		)

	--when loading second vert...	
		on loadVert2 pressed do
		(
			LoadSecVert ()
			if Not useHelpersBut.checked then
			(
				if isValidNode SphereOuterHelper1 then 
				(
					delete SphereOuterHelper1
					try
					(
						--set val = radius, set position to vertPosition, make sphere helper, and lock scale by setting a blank expression controller
						val = RadialFalloff.value
						VertPos = FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos
						SphereOuterHelper1 = SphereGizmo name:"FBAvgWt_RadialHelper1" radius:val pos:VertPos
						SphereOuterHelper1.scale.controller = Scale_Expression ()
					)catch()
				)
				if isValidNode SphereOuterHelper2 then 
				(
					delete SphereOuterHelper2
					try
					(
						val = RadialFalloff.value
						VertPos = FBavgWtObj2.verts[(substring loadVert2.caption 8 -1) as integer].pos
						--SphereOuterHelper2 = SphereGizmo name:"FBAvgWt_RadialHelper2" radius:val pos:VertPos
						SphereOuterHelper2 = gravity name:"FBAvgWt_RadialHelper2" iconSize:val pos:VertPos gravitytype:1
						SphereOuterHelper2.scale.controller = Scale_Expression ()
					)catch()
				)
			)
			else
			(
				try
				(
					SphereOuterHelper2.pos = (FBavgWtObj2.verts[(substring loadVert2.caption 8 -1) as integer].pos)
				)catch()
			)
			
			
		)

	--when selecting stored vertex2
		on selectVert2 pressed do
		(
			if Not (isValidNode FBavgWtObj2) do return 0
			try
			(
				max modify mode
				if (classOf (modPanel.getCurrentObject()) != Skin) then
					modPanel.setCurrentObject FBavgWtObj2.modifiers[#Skin]
				subobjectLevel = 1
				FBavgWtObj2.modifiers[#Skin].filter_vertices = on
				skinOps.SelectVertices FBavgWtObj2.modifiers[#Skin] ((substring loadVert2.caption 8 -1) as integer)
			)
			catch ()
		)

		
	--when Paste Blend is pressed
		on DoIt pressed do
		(
			--abort if no object selected
			if ($selection.count < 1) then
				return 0
			
			if (loadVert1.caption == "Load Vert 1" And Not (loadVert2.caption == "Load Vert 2")) do 
			(
				tempIndex = 0
				
				--LoadFirstVert function, just load one Vert instead of 2
				tempIndex = LoadFirstVert (false)
				FBAverageWeights tempIndex  ((substring loadVert2.caption 8 -1) as integer) ($selection[1]) FBavgWtObj2 (blendWeight.value as float) maintainBoneLimit.checked 0
				return 1
			)
			if (loadVert2.caption == "Load Vert 2" And Not (loadVert1.caption == "Load Vert 1")) do
			(
				--LoadSecVert function, temporary
				tempIndex = LoadSecVert ()
				FBAverageWeights ((substring loadVert1.caption 8 -1) as integer)  tempIndex FBavgWtObj1 ($selection[1]) (blendWeight.value as float) maintainBoneLimit.checked 0
				return 2
			)
			--check to see if both vert1 and vert2 aren't loaded, if not, cancel out with return 0
			if (loadVert1.caption == "Load Vert 1" Or loadVert2.caption == "Load Vert 2") then return 0
			--otherwise, normally call FBAverageWeights
			else
				FBAverageWeights ((substring loadVert1.caption 8 -1) as integer)  ((substring loadVert2.caption 8 -1) as integer) FBavgWtObj1 FBavgWtObj2 (blendWeight.value as float) maintainBoneLimit.checked 0

		)
	--blendWith 1		
		on Blend1 pressed do
		(
			if ($selection.count < 1) then return 0
			
			if (loadVert1.caption != "Load Vert 1" ) do
												--Vert1 Vert2 FBavgWtObj1 FBavgWtObj2 blendWeight maintainBoneLimit BlendCurr
				FBAverageWeights ((substring loadVert1.caption 8 -1) as integer) ((substring loadVert1.caption 8 -1) as integer) FBavgWtObj1 $selection[1] (blendWeight.value as float) maintainBoneLimit.checked 1
		)
	--blendWith 2
		on Blend2 pressed do
		(
			if ($selection.count < 1) then return 0
				
			if (loadVert2.caption != "Load Vert 2" ) do
				FBAverageWeights ((substring loadVert2.caption 8 -1) as integer) ((substring loadVert2.caption 8 -1) as integer) $selection[1] FBavgWtObj2 (blendWeight.value as float) maintainBoneLimit.checked 2
		)
	--Show/Hide Helpers
		on ShowHideHelpers pressed do
		(
			BothDeleted = false
			BothVisible = false
			
			if isValidNode SphereOuterHelper1 then 
			(
				delete SphereOuterHelper1
				BothDeleted = true
			)
			else
			(
				try
				(
					--set val = radius, set position to vertPosition, make sphere helper, and lock scale by setting a blank expression controller
					val = RadialFalloff.value
					VertPos = FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos
					SphereOuterHelper1 = SphereGizmo name:"FBAvgWt_RadialHelper1" radius:val pos:VertPos
					SphereOuterHelper1.scale.controller = Scale_Expression ()
					BothVisible = true
				)
				catch()
			)
			if isValidNode SphereOuterHelper2 and BothDeleted then 
				delete SphereOuterHelper2
			else if BothVisible then
			(
				try
				(
					--set val = radius, set position to vertPosition, make sphere helper, and lock scale by setting a blank expression controller
					val = RadialFalloff.value
					VertPos = FBavgWtObj2.verts[(substring loadVert2.caption 8 -1) as integer].pos
					if Not isValidNode SphereOuterHelper2 then
					(
						--SphereOuterHelper2 = SphereGizmo name:"FBAvgWt_RadialHelper2" radius:val pos:VertPos
						SphereOuterHelper2 = gravity name:"FBAvgWt_RadialHelper2" iconSize:val pos:VertPos gravitytype:1
						SphereOuterHelper2.scale.controller = Scale_Expression ()
					)
					else
						SphereOuterHelper2.pos = VertPos
					
				)
				catch()
			)
		)
	--Use Helper Positions
		on useHelpersBut changed useHelpers do
		(
			if Not useHelpers do
			(
				if isValidNode FBavgWtObj1 then
				(
					if isValidNode SphereOuterHelper1 then 
					(
						SphereOuterHelper1.pos = FBavgWtObj1.verts[(substring loadVert1.caption 8 -1) as integer].pos
					)
				)
				
				if isValidNode FBavgWtObj2 then
				(
					if isValidNode SphereOuterHelper2 then 
					(
						SphereOuterHelper2.pos = FBavgWtObj1.verts[(substring loadVert2.caption 8 -1) as integer].pos
					)
				)
			)
		)		

	)--end Rollout definition
	
	--first delete any helpers or spacewarps that were accidentally saved or something
	--this can get slow, so comment it out if you want to skip this step
		
		for temp in helpers do
		(
			if (matchPattern temp.name  pattern: "FBAvgWt_RadialHelper*") then
			(
				YesNo = queryBox ("unnecessary " + temp.name + " found in this file! \nDo you want to delete it?")
				if YesNo then
					delete temp
			)
		)
		for temp in spacewarps do
		(
			if (matchPattern temp.name  pattern: "FBAvgWt_RadialHelper*") then
			(
				YesNo = queryBox ("unnecessary " + temp.name + " found in this file! \nDo you want to delete it?")
				if YesNo then
					delete temp
			)
		)
	
	--comment out up to this point
		
		
	--get rid of any instance of the dialog already open
	try(destroyDialog FBAverageWeightsUI);	catch()
	--and make a new one
	createDialog FBAverageWeightsUI 220 165
	
)--End macroscript definition